﻿-- Compleater
local frame, events, playSound, expired, infoFader = CreateFrame("Frame"), {}, 0, 0, 0;
-- Timers
local timer, timer025, timer1, timer5, secLeft = 0, 0, 0, 0, 0;
-- Table of fishing poles
local fishpoles = {6256,6365,6366,6367,12225,19022,19970,25978,44050,45858,45991,45992,46337,52678};

-- check skill level and skill training
function events:CHAT_MSG_SKILL(msg)
  -- Check if there is a SKILL tag
  if TourGuide.tags[TourGuide.current]:match("|SKILL|") then TGTradeS:SKILL() end

  -- Check if there is a LVLTOSKILL tag
  if TourGuide.tags[TourGuide.current]:match("|LVLTOSKILL|") then TGTradeS:LVLTOSKILL() end
end

-- Check for new learned item recipe
function events:CHAT_MSG_SYSTEM(msg, ...)
  -- Remove profession from DB if a profession is unlearned and clear UnknownRecipe from DB so there will not be any mix ups
  if msg:match("You have unlearned |cff71d5ff|Hspell:%d+|h%[(.+)%]|h|r.") then
    local ProfName = msg:match("You have unlearned |cff71d5ff|Hspell:%d+|h%[(.+)%]|h|r.")
    if TGTradeS.db.char[ProfName] then TGTradeS.db.char[ProfName] = nil end
    TGTradeS.db.char.UnknownRecipe = {}
  end

  -- Check if there is a TRAINSKILL tag
  if msg:match("You have learned a new ability: (.+).") and TourGuide.tags[TourGuide.current]:match("|TRAINSKILL|") then
    TGTradeS:TRAINSKILL(msg)
  end

  -- Check if there is a LEARNITEM tag
  if msg:match("You have learned how to create a new item: ([%a:%s]+).") then
    tinsert(TGTradeS.db.char.UnknownRecipe, msg:match("You have learned how to create a new item: ([%a:%s]+)."))
    if TourGuide.tags[TourGuide.current]:match("|LEARNITEM|") then TGTradeS:LEARNITEM(msg) end
  end
end

-- Check for currentcy change
function events:CURRENCY_DISPLAY_UPDATE()
  if TourGuide.tags and TourGuide.tags[TourGuide.current]:match("|CURRENCY|") then TGTradeS:CURRENCY() end
end

-- Check for bag updates
function events:BAG_UPDATE(bId)
  -- If bag id is 0-4 then execute script
  if bId >= 0 and bId <= 4 then
    -- Check if there is a LOOT tag
    if TourGuide.tags[TourGuide.current]:match("|LOOT|") then TGTradeS:LOOT() end
    if TourGuide.tags[TourGuide.current]:match("|TLOOT|") then TGTradeS:TLOOT() end
  end
end

-- Check for player level up
function events:PLAYER_LEVEL_UP(level)
  if TourGuide.tags[TourGuide.current]:match("|LVL|") then TGTradeS:LVL(level) end
end

frame:SetScript("OnEvent",
  function(self, event, ...)
    events[event](self, ...)
  end
)

for k, v in pairs(events) do
  frame:RegisterEvent(k)
end

frame:SetScript("OnUpdate",
  function(Self,LastUpdate)
    -- Make sure TourGuide addon is loaded
    if IsAddOnLoaded("TourGuide") and IsAddOnLoaded("TourGuide-Tradeskill") then
      local tags = TourGuide.tags[TourGuide.current]
      ---------------------------------------
      -- Cleanup Controller
      ---------------------------------------
      if TGTradeS.guideId ~= TourGuide.current then
        TGTradeS.guideId = TourGuide.current
        local done = false;
        -- Hide the Extra Info Frame so it's ready to update
        TGTradeS.extObj:Hide();

        -- Hide the map icon so it's ready to update
        TourGuide.statusframe.Map:Hide()

        -- Check CURRENCY tag
        if tags:match("|CURRENCY|") then
          done = TGTradeS:CURRENCY();
        end

        -- Check DONTHAVESKILL tag
        if tags:match("|DONTHAVESKILL|") and done == false then
          done = TGTradeS:DONTHAVESKILL();
        end

        -- Check HAVESKILL tag
        if tags:match("|HAVESKILL|") and done == false then
          done = TGTradeS:HAVESKILL();
        end

        -- Check LEARNITEM tag
        if tags:match("|LEARNITEM|") and done == false then
          done = TGTradeS:LEARNITEM();
        end

        -- Check LOOT tag
        if tags:match("|LOOT|") and done == false then
          done = TGTradeS:LOOT();
        end

        -- Check LVL tag
        if tags:match("|LVL|") and done == false then
          done = TGTradeS:LVL();
        end

        -- Check LVLTOSKILL tag
        if tags:match("|LVLTOSKILL|") and done == false then
          done = TGTradeS:LVLTOSKILL();
        end

        -- Check MAP tag
        if tags:match("|MAP|") and done == false then
          done = TGTradeS:MAP();
        end

        -- Check SKILL tag
        if tags:match("|SKILL|") and done == false then
          done = TGTradeS:SKILL();
        end

        -- Check TLOOT tag
        if tags:match("|TLOOT|") and done == false then
          done = TGTradeS:TLOOT();
        end

        -- Check TRAINSKILL tag
        if tags:match("|TRAINSKILL|") and done == false then
          done = TGTradeS:TRAINSKILL();
        end

        -- Check LOOT tag again since we would like to auto buy if the new objective is not
        -- complete and player is interacting with an merchant and the merchant have that item for sale
        if tags:match("|LOOT|") and done == false and TGTradeS.db.char.atmerchant then
          TGTradeS:AutoBuyFromMerchant()
        end

        -- Check LEARNITEM tag again since we would like to auto learn if the new objective is not
        -- complete and player is interacting with an trainer and the trainer have that recipe
        if tags:match("|LEARNITEM|") and done == false and TGTradeS.db.char.attrainer then
          TGTradeS:AutoLearnFromTrainer()
        end

        done = false;
      end -- if guideId
      ---------------------------------------
      -- End Cleanup Controller
      ---------------------------------------

      tags = TourGuide.tags[TourGuide.current]
      ---------------------------------------
      -- Extra Info Frame Controller
      ---------------------------------------
      if not TGTradeS.extObj:IsShown() then
        if tags:match("|LVLTOSKILL|") or tags:match("|LOOT|") or tags:match("|TLOOT|") or tags:match("|CURRENCY|") then
          TGTradeS.extObj:Show();
        end
      end
      ---------------------------------------
      -- End Extra Info Frame Controller
      ---------------------------------------

      ---------------------------------------
      -- Map Tag Controller
      ---------------------------------------
      if (not TourGuide.statusframe.Map:IsShown()) then
        if tags:match("|MAP|") then
          TourGuide.statusframe.Map:Show()
        end
      end
      ---------------------------------------
      -- End Map Tag Controller
      ---------------------------------------

      ---------------------------------------
      -- Lure alert sound controller
      ---------------------------------------
      -- only run this script if |U|se tag is presended
      -- This is used for warning bip when lure is almost runned out
      if tags:match("|U|") then
        -- check if player have a fishing pole equipped
        for i,v in ipairs(fishpoles) do
          local poleName = TGTradeS:GetItemInfos(v);
          local poleEquipped = IsEquippedItem(v);
          if poleEquipped then
            hasMainHandEnchant, mainHandExpiration = GetWeaponEnchantInfo();
            -- Play sound if fishing pole have lures on it that is soon to run out
            if hasMainHandEnchant then
              secLeft = floor(mainHandExpiration/1000);

              -- Show that enchant expired
              if secLeft <= 0 and expired == 0 then
                print(string.format("|cffffff00%s|r |cFFFF6060lure expired|r",poleName));
                expired = 1;

              -- Play bip fast
              elseif secLeft < 1 and expired == 0 then
                timer025 = timer025 + LastUpdate;
                if timer025 >= 0.25 then
                  timer025 = timer025 - 0.25;
                  playSound = 1;
                end

              -- Play bip each second
              elseif secLeft <= 5 and expired == 0 then
                timer1 = timer1 + LastUpdate;
                if timer1 >= 1 then
                  timer1 = timer1 - 1;
                  playSound = 1;
                  print(string.format("|cffffff00%s|r |cFFFF6060lure expire in: %isec|r",poleName,secLeft));
                end

              -- Play bip each 5 second
              elseif secLeft <= 20 then
                timer5 = timer5 + LastUpdate;
                if timer5 >= 5 then
                  timer5 = timer5 - 5;
                  playSound = 1;
                  print(string.format("|cffffff00%s|r |cFFFF6060lure expire in: %isec|r",poleName,secLeft));
                end

              -- Reset 1 and 5 sec counter if not reset
              elseif secLeft > 20 and timer5 ~= 0 or timer1 ~= 0 or expired ~= 0 then
                timer1 = 0;
                timer5 = 0;
                expired = 0;
              end

              if playSound == 1 then
                if TGTradeS.db.profile.Config.LureAlert then PlaySoundFile("Interface\\AddOns\\TourGuide-Tradeskill\\Sounds\\bip.mp3", "SFX"); end
                playSound = 0;
              end -- if playSound
            else
              if expired ~= 0 then expired = 0 end
            end -- if hasMainHandEnchant
          end -- if poleEquipped
        end -- for i,v
      end -- if TourGuide.tags
      ---------------------------------------
      -- End Lure alert sound controller
      ---------------------------------------
    end -- if IsAddOnLoaded
  end -- function
)